<template>
  <div>
    <!-- Cuerpo -->
    <div style="margin: 0 4rem" class="padding-top">
      <el-header style="height: auto; margin: 0 2.75rem;">
        <el-row :gutter="15">
          <!-- Filtros -->
          <el-col :span="20" :offset="5">
            <el-col :span="9">
              <app-select v-model="filterSelect" :filterArray="allFilters"></app-select>
            </el-col>
            <el-col :span="11">
              <el-input
                class="input-head"
                placeholder="Buscar"
                prefix-icon="el-icon-search"
                v-model="textSearch"
                @clear="cleanSearch"
                @keyup.enter.native="filterMaterials"
                clearable
              ></el-input>
            </el-col>
            <el-col :span="2">
              <el-button @click="filterMaterials" type="primary" :disabled="textSearch==''">BUSCAR</el-button>
            </el-col>
          </el-col>
        </el-row>

        <!-- Subtítulo -->
        <el-col :span="24">
          <div class="titleSection">Lista de Programas</div>
        </el-col>

        <!-- Botón nuevo -->
        <div class="text-end" style="margin-top: 3rem">
          <el-button @click="goToNewProgram" type="primary">NUEVO PROGRAMA</el-button>
        </div>
      </el-header>
      <div
        v-bind:class="[ programs.length == 0 ? 'remove-grid-container' : 'grid-container' ]"
        v-loading="loading"
        :element-loading-text="loadingText"
      >
        <!-- Tarjetas -->
        <el-row
          v-bind:class="[ programs.length == 0 ? 'grid-container' : '' ]"
          v-if="programs && programs.length"
          v-loading="loading"
          :element-loading-text="loadingText"
        >
          <el-col
            v-for="(program, index) in programs"
            style="margin-bottom: 4rem"
            :key="program.__id"
          >
            <app-cards
              :principalTitle="program.programTitle"
              :showAmounts="true"
              :showvalidity="true"
              :showWindow="false"
              :principalData="{ 
                0:{ class: 'bg-orange-ligth text-white', subTitle: 'Cod. Programa', content: program.codProgram} ,
                1:{ class: 'bg-orange-ligth text-white', subTitle: 'Cod. Géminis', content: program.geminisCode} 
                }"
              :dataTable="programs[index].validity"
              :textModal="textModal"
              :uniqueId="program._id"
              :item="program"
              :cutRoute="''"
              :editRoute="editRoute"
              @executeEdit="editProgram($event)"
              @executeChangeStatus="statusChange(program)"
              :rowsInfo="{
                              0: {
                                showDefault: true,
                                left: { subtitle: 'Horario', content: `<strong>Inicio:</strong>&nbsp;<span>${validationSchudle(program.scheduleStartHour, program.scheduleStartMin)}</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<strong>Fin:</strong>&nbsp;<span>${validationSchudle(program.scheduleEndHour, program.scheduleEndMin)}</span>`},
                              },
                              1: {
                                showDefault: true,
                                left: { subtitle: 'Tipo de Contenido', content: program.typeOfContent },
                                right: { subtitle: 'Precio por día', content: program.priceForDay !== null && program.priceForDay !== ''  &&  program.priceForDay !== undefined ? `USD ${program.priceForDay}`: '' }
                              },
                              2:{
                                showDefault: true,
                                left: { subtitle: 'Transmisión', content: program.transmissionDays.join(', ')},
                                right: { subtitle: 'Señales', content: (program.checkedSignals).join(', ') },
                              },
                              3:{
                                showDefault: true,
                                left: { subtitle: 'Canal de Transmisión', content: (program.checkedChanels.join(', '))  }
                              }   
                            }"
            ></app-cards>
          </el-col>
        </el-row>
        <!-- Tarjeta 'No hay resultado' -->
        <el-row class="grid-container">
          <el-col v-if="isShowNoResults">
            <el-card :body-style="{ padding: '0px' }" class="bg-gray">
              <el-col :span="8" style="margin-top: 1rem" class="text-center">
                <img src="@/assets/images/detective.svg" alt />
              </el-col>
              <el-col :span="16">
                <div style="margin-top: 5rem">
                  <p class="title-styles">¡Lo sentimos!</p>
                  <p class="title-styles">{{existProgram}}</p>
                </div>
              </el-col>
            </el-card>
          </el-col>
        </el-row>
      </div>
    </div>
  </div>
</template>

<script>
import Cards from '@/components/cards.vue'
import SearchFilter from '@/components/searchFilter.vue'
import Select from '@/components/AppSelect.vue'
import { mapGetters, mapMutations, mapActions, mapState } from 'vuex'
import { modifyText } from '@/utils/modifyText.js'
import {HTTP} from '@/main.js'


export default {
  components: {
    'app-cards': Cards,
    'app-search-filter': SearchFilter,
    'app-select': Select
  },
  data () {
    return {
      textSearch: '',
      filterSelect: '',
      programsInfo: [],
      editRoute: 'newProgram',
      textModal: 'programa',
      IsClick: false,
      allPrograms:[],
      searchPrograms:[],
      isShowNoResults: false,
      allFilters: [
        {value: 'codProgram', label: 'Código del programa'},
        {value: 'programType', label: 'Tipo de contenido'},
        {value: 'startValidity', label: 'Vigencia - Inicio'},
        {value: 'endValidity', label: 'Vigencia - Fin'}
      ],
      loading: true,
      loadingText: 'Cargando Programas...',
      existProgram: 'No encontramos resultados para tu búsqueda'
    }
  },
  computed: {
   programs () {return this.IsClick? this.searchPrograms:this.allPrograms}
  },
  created () {
    this.getPrograms()
    this.verifyContent()
  },
  methods: {
    filterMaterials() {
      let cadenaConexion
      console.log(this.filterSelect, 'this.filterSelect')
      console.log(this.textSearch, 'this.textSearch')
      if ( this.filterSelect == 'startValidity' || this.filterSelect == 'endValidity' && this.textSearch !== ''  ) {
        var myDate = this.textSearch ;
        myDate=myDate.split("/");
        var newDate = myDate[1]+"/"+myDate[0]+"/"+myDate[2];
        var timestamp = new Date(newDate).getTime() 
        var prueba = {date: this.textSearch }
        console.log('1 ',`programs/typeOfFilter/${this.filterSelect}/word/${ timestamp }`)
        cadenaConexion =  HTTP.get(`programs/typeOfFilter/${this.filterSelect}/word/${ timestamp }`)
      }
      else if (this.filterSelect == '' &&  this.textSearch !== '' ) {   
        console.log('2 ',`programs/typeOfFilter/programTitle/word/${this.textSearch}`);
        cadenaConexion =  HTTP.get(`programs/typeOfFilter/programTitle/word/${this.textSearch}`)
      }
      else {       
        console.log('3 ',`programs/typeOfFilter/${this.filterSelect}/word/${this.textSearch}`)
        cadenaConexion =  HTTP.get(`programs/typeOfFilter/${this.filterSelect}/word/${this.textSearch}`)
      }
      cadenaConexion
      .then(res=> {
        this.existProgram = 'No encontramos resultados para tu búsqueda'
        this.isShowNoResults = res.data.programs.length == 0  ? true : false
        this.searchPrograms = res.data.programs;
        this.IsClick = true
      })
    },
    cleanSearch() {
      this.IsClick = false
      this.filterSelect =  ''
      this.isShowNoResults = false
    },
    async getPrograms () {
      this.loading = true;
      this.$localStorage.set('programId', JSON.stringify(''))
      // HTTP.get('programs')
      // .then(res=>{
      //   this.allPrograms = res.data.programs;
      //   this.loading = !this.allPrograms.length>0;
      // })
      try {
        const {data} =  await HTTP.get('programs')
        if(data.programs && data.programs.length > 0) {
          this.allPrograms = data.programs
        } else {
          this.allPrograms = []
          this.isShowNoResults = true
          this.existProgram =  'No existen Programas disponibles'
        }
        this.loading = false
      }catch(err) {
        console.log({err})
      }
    },
    goToNewProgram () {
      sessionStorage.setItem('newOrEditProgram', JSON.stringify('newProgram'))
      // this.cardsData[i].programDate = JSON.parse(sessionStorage.getItem('dia'))
      this.$router.push({ name: "newProgram" })
    },
    statusChange (item) {
      const payload = {
        type: 'programs',
        id: item._id,
        payloadInfo: item
      }
      this.$store.dispatch('changeStatus',payload)
    },
    editProgram (event) {
      let targetId = event.target.parentElement.parentElement.id;
      sessionStorage.setItem('newOrEditProgram', JSON.stringify('editProgram'))
      this.$localStorage.set('programId', JSON.stringify(targetId))
    },
    verifyContent() {
      if(this.programs.length > 0) {
        this.loading = false
      } else {
          this.loading = this.programs.length == 0 && this.textSearch !== '' ? false : true
      }
    },
    validationSchudle(hour, mins) {
      if (hour !== undefined && hour !== '') {
        hour = hour
        if (mins != undefined) {
          if (mins !== '') {
            mins = ':' + mins
          }
          else {
            mins = ':00'
          }
          
        }
        else {
          mins = ':00'
        }
        
      }
      else {
        hour = ''
        mins = ''
      }
      return hour + ' ' + mins
    },
  },
  watch: {
    programs(val) {
      this.verifyContent()
    }
  }
}
</script>

<style scoped>
.titleSection {
  background: #4a4a4a;
  color: white;
  padding: 10px 10px 10px 35px;
  text-transform: uppercase;
  font-weight: 400;
  margin: 40px auto;
  font-size: 18px;
}
</style>